"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compareSemver = void 0;
const gt_1 = __importDefault(require("semver/functions/gt"));
const lt_1 = __importDefault(require("semver/functions/lt"));
const clean_1 = require("./clean");
const get_range_score_1 = require("./get-range-score");
const EQ = 0;
const LT = -1;
const GT = 1;
function compareSemver(a, b) {
    if (a.startsWith('workspace:'))
        return LT;
    if (b.startsWith('workspace:'))
        return GT;
    if (a === b)
        return EQ;
    if (a === '*')
        return GT;
    if (b === '*')
        return LT;
    const cleanA = (0, clean_1.clean)(a);
    const cleanB = (0, clean_1.clean)(b);
    if ((0, gt_1.default)(cleanA, cleanB))
        return GT;
    if ((0, lt_1.default)(cleanA, cleanB))
        return LT;
    const scoreA = (0, get_range_score_1.getRangeScore)(a);
    const scoreB = (0, get_range_score_1.getRangeScore)(b);
    if (scoreA < scoreB)
        return LT;
    if (scoreA > scoreB)
        return GT;
    return EQ;
}
exports.compareSemver = compareSemver;
