"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLowestVersion = void 0;
const Function_1 = require("@effect/data/Function");
const is_non_empty_string_1 = require("tightrope/guard/is-non-empty-string");
const filter_1 = require("tightrope/result/filter");
const from_try_1 = require("tightrope/result/from-try");
const map_1 = require("tightrope/result/map");
const compare_semver_1 = require("./compare-semver");
function getLowestVersion(versions) {
    return (0, Function_1.pipe)((0, from_try_1.fromTry)(() => [...versions].sort(compare_semver_1.compareSemver)), (0, map_1.map)(([lowest]) => lowest), (0, filter_1.filter)(is_non_empty_string_1.isNonEmptyString, 'getLowestVersion(): did not return a version'));
}
exports.getLowestVersion = getLowestVersion;
