"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logVerbose = void 0;
const chalk_1 = __importDefault(require("chalk"));
const is_string_1 = require("tightrope/guard/is-string");
const util_1 = require("util");
const constants_1 = require("../constants");
function logVerbose(...values) {
    /* istanbul ignore if */
    if (process.env.SYNCPACK_VERBOSE) {
        console.info(chalk_1.default.yellow(constants_1.ICON.debug), ...values.map((value) => (0, is_string_1.isString)(value)
            ? chalk_1.default.yellow(value)
            : (0, util_1.inspect)(value, {
                colors: true,
                compact: true,
                depth: 20,
                showHidden: false,
            })));
    }
}
exports.logVerbose = logVerbose;
