"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNonEmptyStringProp = void 0;
const Function_1 = require("@effect/data/Function");
const get_1 = require("tightrope/fn/get");
const is_non_empty_string_1 = require("tightrope/guard/is-non-empty-string");
const filter_1 = require("tightrope/result/filter");
const map_err_1 = require("tightrope/result/map-err");
function getNonEmptyStringProp(propPath, file) {
    return (0, Function_1.pipe)((0, get_1.get)(file.contents, ...propPath.split('.')), (0, filter_1.filter)(is_non_empty_string_1.isNonEmptyString, ''), (0, map_err_1.mapErr)(() => new Error(`Failed to get ${propPath} in ${file.shortPath}`)));
}
exports.getNonEmptyStringProp = getNonEmptyStringProp;
